/*
 * <<< shlib.h >>>
 *
 * --- Synchronization library for attempt-1, isis, etc... 'shlib.h'
 *     Copyright (C) 1998-2000 Amano Lab., Keio University. ---
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 */

#ifndef __SHLIB_H
#define __SHLIB_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <sys/types.h> /* size_t */

int get_punum(void);
int get_puid(void);
void barrier(void);
void *shared_malloc(size_t);
void shared_free(void*);
void *sync_malloc(size_t);
void sync_free(void*);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __SHLIB_H */
